﻿package {
	import flash.display.Sprite;
	import Direction;
	import Pad;
	public class Ball extends Sprite {
		// Az labda mozgása időközönként pixelekben
		const rate:Number = 3;
		// Az labda iránya
		public var dir:Direction = new Direction(Math.random()*2-1, -4);
		// A labda következő beütközési helye
		private var targetPosition:Number;
		public function Ball(stage) {
			// Rajzoljuk meg a labdát
			graphics.beginFill(0xFFFFFF);
			graphics.drawEllipse(-3, -3, 6, 6);
			graphics.endFill();
			// Pozicionáljuk
			this.x = stage.stageWidth/2;
			this.y = stage.stageHeight/2;
		}
		// A labda mozgását kezelő függvény
		public function move() {
			// Ha kimenne a pályáról, fordítsuk meg az irányát
			if((y+height/2>=stage.stageHeight && dir.y>0)
					|| (y-height/2<=0 && dir.y<0)) {
				dir.y*=-1;
			}
			if((x+width/2>=stage.stageWidth && dir.x>0)
					|| (x-width/2<=0 && dir.x<0)) {
				dir.x*=-1;
			}
			// Amúgy növeljük mindként koordinátáját az adott
			// iránykomponens 1-re normáltjának a rate-szeresével
			x+=rate*dir.normX();
			y+=rate*dir.normY();
		}
		// Kezeljük le, ha az ütővel ütközik
		public function hit(pad:Pad) {
			dir.hit(pad, this);
			// Változni fog a becsapódás helye, számoljuk ki újra
			setTarget();
		}
		// Számoljuk ki a becsapódás helyét
		public function setTarget() {
			// Számoljuk ki a becsapódás abszolút helyét
			if(dir.y<0) {
				targetPosition = x-y*(dir.x/dir.y);
			} else {
				targetPosition = x+(stage.stageHeight-y)*(dir.x/dir.y);
			}
			// Vegyük hozzá a falakról való visszapattanást
			if(targetPosition<0) {
				targetPosition *= -1;
			} else if(targetPosition>stage.stageWidth) {
				targetPosition = stage.stageWidth*2-targetPosition;
			}
		}
		// Visszaadja a becsapódás helyét
		public function getTarget():Number {
			return targetPosition;
		}
		// Visszaadja, hogy elkerülte-e a labda az ütőt.
		public function over(pad:Pad):Boolean {
			return pad.onTop?y-height/2<=pad.y:y+height/2>=pad.y;
		}
		// Berakja a labdát a pálya közepére (mikor valaki pontot veszít)
		public function reset() {
			x = stage.stageWidth/2;
			y = stage.stageHeight/2;
			dir.x = Math.random()*2-1;
			setTarget();
		}
	}
}