﻿package {
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import Direction;
	public class Pad extends Sprite {
		// Az ütő mozgása időközönként
		var rate:Number = 2;
		// Le van-e nyomva a bal kurzorbillentyű
		var leftDown:Boolean;
		// Le van-e nyomva a jobb kurzorbillentyű
		var rightDown:Boolean;
		// Mesterséges intelligencia irányítja-e az ütőt
		var AI:Boolean = true;
		// Felül van-e az ütő.
		var onTop:Boolean = false;
		public function Pad(stage, p_onTop = true, p_AI = true) {
			AI = p_AI;
			onTop = p_onTop;
			// Az ellenfél ütőjét lassítsuk kicsit le.
			if(AI) rate*=0.8;
			// Rajzoljuk ki az ütőt
			graphics.beginFill(0xFFFFFF);
			graphics.drawRect(-40, -3, 80, 6);
			graphics.endFill();
			// Helyezzük el az ütőt a pályán
			this.x = stage.stageWidth/2;
			this.y = onTop?3:stage.stageHeight-3;
			// Figyeljük a billentyűket
			stage.addEventListener(KeyboardEvent.KEY_UP,key_Up);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,key_Down);
		}
		// A mozgást kezelő függvény
		public function move(ball:Ball) {
			// Mi van, ha nem MI a játékos
			if(!AI) {
				// ha a bal le van nyomva, és nincs túl balra
				if(leftDown && this.x>=this.width/2) {
					// vigyük balra az ütőt rate pixellel
					this.x-=rate;
				// ha a jobb le van nyomva, és nincs túl jobbra
				} else if(rightDown
						&& this.x+this.width/2<=stage.stageWidth) {
					// vigyük jobbra az ütőt rate pixellel
					this.x+=rate;
				}
			// Mi van, ha MI a játékos
			} else {
				// vigyük a labda beütközési helye felé az ütőt
				if(ball.getTarget()-rate>x
						&& x+width/2<=stage.stageWidth) {
					x+=rate;
				} else if(ball.getTarget()+rate<x && x>=width/2) {
					x-=rate;
				}
			}
		}
		// Keyboard eseményfigyelők, amik a bal-jobb gombokat kezelik
		private function key_Up(event:KeyboardEvent) {
			switch (event.keyCode) {
				case 37 :
					leftDown = false;
					break;
				case 39 :
					rightDown = false;
					break;
			}
		}
		private function key_Down(event:KeyboardEvent) {
			switch (event.keyCode) {
				case 37 :
					leftDown = true;
					break;
				case 39 :
					rightDown = true;
					break;
			}
		}
	}
}